package eu.jonahbauer.raytracing.scene.util;

import eu.jonahbauer.raytracing.math.Vec3;
import org.jetbrains.annotations.NotNull;

public final class PdfUtil {
    private PdfUtil() {
        throw new UnsupportedOperationException();
    }

    public static double getSolidAngle(@NotNull Vec3 o, @NotNull Vec3 a, @NotNull Vec3 b, @NotNull Vec3 c) {
        var i = a.minus(o).unit();
        var j = b.minus(o).unit();
        var k = c.minus(o).unit();

        return 2 * Math.atan(Math.abs(i.times(j.cross(k))) / (1 + i.times(j) + j.times(k) + k.times(i)));
    }
}
